// "marked" Markdown parser, based on: https://github.com/chjj/marked
// (minified + altered to return the appropriate object)
// MIT-style license:

/*
Copyright (c) 2011-2013, Christopher Jeffrey (https://github.com/chjj/)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
var marked = (function(){function s(a){this.tokens=[];this.tokens.links={};this.options=a||k.defaults;this.rules=e.normal;this.options.gfm&&(this.rules=this.options.tables?e.tables:e.gfm)}function q(a,b){this.options=b||k.defaults;this.links=a;this.rules=h.normal;if(!this.links)throw Error("Tokens array requires a `links` property.");this.options.gfm?this.rules=this.options.breaks?h.breaks:h.gfm:this.options.pedantic&&(this.rules=h.pedantic)}function p(a){this.tokens=[];this.token=null;this.options=a||k.defaults}
function n(a,b){return a.replace(b?/&/g:/&(?!#?\w+;)/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;")}function l(a,b){a=a.source;b=b||"";return function d(c,e){if(!c)return RegExp(a,b);e=e.source||e;e=e.replace(/(^|[^\[])\^/g,"$1");a=a.replace(c,e);return d}}function t(){}function r(a){for(var b=1,m,d;b<arguments.length;b++)for(d in m=arguments[b],m)Object.prototype.hasOwnProperty.call(m,d)&&(a[d]=m[d]);return a}function k(a,b,m){if(m||"function"===
typeof b){m||(m=b,b=null);b=r({},k.defaults,b||{});var d=b.highlight,c,e,f=0;try{c=s.lex(a,b)}catch(g){return m(g)}e=c.length;var h=function(){var a,e;try{a=p.parse(c,b)}catch(f){e=f}b.highlight=d;return e?m(e):m(null,a)};if(!d||3>d.length)return h();delete b.highlight;if(!e)return h();for(;f<c.length;f++)(function(a){return"code"!==a.type?--e||h():d(a.text,a.lang,function(c,b){if(null==b||b===a.text)return--e||h();a.text=b;a.escaped=!0;--e||h()})})(c[f])}else try{return b&&(b=r({},k.defaults,b)),
p.parse(s.lex(a,b),b)}catch(l){l.message+="\nPlease report this to https://github.com/chjj/marked.";if((b||k.defaults).silent)return"<p>An error occured:</p><pre>"+n(l.message+"",!0)+"</pre>";throw l;}}var e={newline:/^\n+/,code:/^( {4}[^\n]+\n*)+/,fences:t,hr:/^( *[-*_]){3,} *(?:\n+|$)/,heading:/^ *(#{1,6}) *([^\n]+?) *#* *(?:\n+|$)/,nptable:t,lheading:/^([^\n]+)\n *(=|-){2,} *(?:\n+|$)/,blockquote:/^( *>[^\n]+(\n[^\n]+)*\n*)+/,list:/^( *)(bull) [\s\S]+?(?:hr|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,html:/^ *(?:comment|closed|closing) *(?:\n{2,}|\s*$)/,
def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +["(]([^\n]+)[")])? *(?:\n+|$)/,table:t,paragraph:/^((?:[^\n]+\n?(?!hr|heading|lheading|blockquote|tag|def))+)\n*/,text:/^[^\n]+/,bullet:/(?:[*+-]|\d+\.)/,item:/^( *)(bull) [^\n]*(?:\n(?!\1bull )[^\n]*)*/};e.item=l(e.item,"gm")(/bull/g,e.bullet)();e.list=l(e.list)(/bull/g,e.bullet)("hr",/\n+(?=(?: *[-*_]){3,} *(?:\n+|$))/)();e._tag="(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:/|@)\\b";
e.html=l(e.html)("comment",/\x3c!--[\s\S]*?--\x3e/)("closed",/<(tag)[\s\S]+?<\/\1>/)("closing",/<tag(?:"[^"]*"|'[^']*'|[^'">])*?>/)(/tag/g,e._tag)();e.paragraph=l(e.paragraph)("hr",e.hr)("heading",e.heading)("lheading",e.lheading)("blockquote",e.blockquote)("tag","<"+e._tag)("def",e.def)();e.normal=r({},e);e.gfm=r({},e.normal,{fences:/^ *(`{3,}|~{3,}) *(\S+)? *\n([\s\S]+?)\s*\1 *(?:\n+|$)/,paragraph:/^/});e.gfm.paragraph=l(e.paragraph)("(?!","(?!"+e.gfm.fences.source.replace("\\1","\\2")+"|"+e.list.source.replace("\\1",
"\\3")+"|")();e.tables=r({},e.gfm,{nptable:/^ *(\S.*\|.*)\n *([-:]+ *\|[-| :]*)\n((?:.*\|.*(?:\n|$))*)\n*/,table:/^ *\|(.+)\n *\|( *[-:]+[-| :]*)\n((?: *\|.*(?:\n|$))*)\n*/});s.rules=e;s.lex=function(a,b){return(new s(b)).lex(a)};s.prototype.lex=function(a){a=a.replace(/\r\n|\r/g,"\n").replace(/\t/g,"    ").replace(/\u00a0/g," ").replace(/\u2424/g,"\n");return this.token(a,!0)};s.prototype.token=function(a,b){a=a.replace(/^ +$/gm,"");for(var m,d,c,h,f,g,k;a;){if(c=this.rules.newline.exec(a))a=a.substring(c[0].length),
1<c[0].length&&this.tokens.push({type:"space"});if(c=this.rules.code.exec(a))a=a.substring(c[0].length),c=c[0].replace(/^ {4}/gm,""),this.tokens.push({type:"code",text:this.options.pedantic?c:c.replace(/\n+$/,"")});else if(c=this.rules.fences.exec(a))a=a.substring(c[0].length),this.tokens.push({type:"code",lang:c[2],text:c[3]});else if(c=this.rules.heading.exec(a))a=a.substring(c[0].length),this.tokens.push({type:"heading",depth:c[1].length,text:c[2]});else if(b&&(c=this.rules.nptable.exec(a))){a=
a.substring(c[0].length);f={type:"table",header:c[1].replace(/^ *| *\| *$/g,"").split(/ *\| */),align:c[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:c[3].replace(/\n$/,"").split("\n")};for(g=0;g<f.align.length;g++)/^ *-+: *$/.test(f.align[g])?f.align[g]="right":/^ *:-+: *$/.test(f.align[g])?f.align[g]="center":/^ *:-+ *$/.test(f.align[g])?f.align[g]="left":f.align[g]=null;for(g=0;g<f.cells.length;g++)f.cells[g]=f.cells[g].split(/ *\| */);this.tokens.push(f)}else if(c=this.rules.lheading.exec(a))a=
a.substring(c[0].length),this.tokens.push({type:"heading",depth:"="===c[2]?1:2,text:c[1]});else if(c=this.rules.hr.exec(a))a=a.substring(c[0].length),this.tokens.push({type:"hr"});else if(c=this.rules.blockquote.exec(a))a=a.substring(c[0].length),this.tokens.push({type:"blockquote_start"}),c=c[0].replace(/^ *> ?/gm,""),this.token(c,b),this.tokens.push({type:"blockquote_end"});else if(c=this.rules.list.exec(a)){a=a.substring(c[0].length);h=c[2];this.tokens.push({type:"list_start",ordered:1<h.length});
c=c[0].match(this.rules.item);m=!1;k=c.length;for(g=0;g<k;g++)f=c[g],d=f.length,f=f.replace(/^ *([*+-]|\d+\.) +/,""),~f.indexOf("\n ")&&(d-=f.length,f=this.options.pedantic?f.replace(/^ {1,4}/gm,""):f.replace(RegExp("^ {1,"+d+"}","gm"),"")),this.options.smartLists&&g!==k-1&&(d=e.bullet.exec(c[g+1])[0],h===d||1<h.length&&1<d.length||(a=c.slice(g+1).join("\n")+a,g=k-1)),d=m||/\n\n(?!\s*$)/.test(f),g!==k-1&&(m="\n"===f.charAt(f.length-1),d||(d=m)),this.tokens.push({type:d?"loose_item_start":"list_item_start"}),
this.token(f,!1),this.tokens.push({type:"list_item_end"});this.tokens.push({type:"list_end"})}else if(c=this.rules.html.exec(a))a=a.substring(c[0].length),this.tokens.push({type:this.options.sanitize?"paragraph":"html",pre:"pre"===c[1]||"script"===c[1]||"style"===c[1],text:c[0]});else if(b&&(c=this.rules.def.exec(a)))a=a.substring(c[0].length),this.tokens.links[c[1].toLowerCase()]={href:c[2],title:c[3]};else if(b&&(c=this.rules.table.exec(a))){a=a.substring(c[0].length);f={type:"table",header:c[1].replace(/^ *| *\| *$/g,
"").split(/ *\| */),align:c[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:c[3].replace(/(?: *\| *)?\n$/,"").split("\n")};for(g=0;g<f.align.length;g++)/^ *-+: *$/.test(f.align[g])?f.align[g]="right":/^ *:-+: *$/.test(f.align[g])?f.align[g]="center":/^ *:-+ *$/.test(f.align[g])?f.align[g]="left":f.align[g]=null;for(g=0;g<f.cells.length;g++)f.cells[g]=f.cells[g].replace(/^ *\| *| *\| *$/g,"").split(/ *\| */);this.tokens.push(f)}else if(b&&(c=this.rules.paragraph.exec(a)))a=a.substring(c[0].length),
this.tokens.push({type:"paragraph",text:"\n"===c[1].charAt(c[1].length-1)?c[1].slice(0,-1):c[1]});else if(c=this.rules.text.exec(a))a=a.substring(c[0].length),this.tokens.push({type:"text",text:c[0]});else if(a)throw Error("Infinite loop on byte: "+a.charCodeAt(0));}return this.tokens};var h={escape:/^\\([\\`*{}\[\]()#+\-.!_>])/,autolink:/^<([^ >]+(@|:\/)[^ >]+)>/,url:t,tag:/^\x3c!--[\s\S]*?--\x3e|^<\/?\w+(?:"[^"]*"|'[^']*'|[^'">])*?>/,link:/^!?\[(inside)\]\(href\)/,reflink:/^!?\[(inside)\]\s*\[([^\]]*)\]/,
nolink:/^!?\[((?:\[[^\]]*\]|[^\[\]])*)\]/,strong:/^__([\s\S]+?)__(?!_)|^\*\*([\s\S]+?)\*\*(?!\*)/,em:/^\b_((?:__|[\s\S])+?)_\b|^\*((?:\*\*|[\s\S])+?)\*(?!\*)/,code:/^(`+)\s*([\s\S]*?[^`])\s*\1(?!`)/,br:/^ {2,}\n(?!\s*$)/,del:t,text:/^[\s\S]+?(?=[\\<!\[_*`]| {2,}\n|$)/,_inside:/(?:\[[^\]]*\]|[^\[\]]|\](?=[^\[]*\]))*/,_href:/\s*<?([\s\S]*?)>?(?:\s+['"]([\s\S]*?)['"])?\s*/};h.link=l(h.link)("inside",h._inside)("href",h._href)();h.reflink=l(h.reflink)("inside",h._inside)();h.normal=r({},h);h.pedantic=
r({},h.normal,{strong:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,em:/^_(?=\S)([\s\S]*?\S)_(?!_)|^\*(?=\S)([\s\S]*?\S)\*(?!\*)/});h.gfm=r({},h.normal,{escape:l(h.escape)("])","~|])")(),url:/^(https?:\/\/[^\s<]+[^<.,:;"')\]\s])/,del:/^~~(?=\S)([\s\S]*?\S)~~/,text:l(h.text)("]|","~]|")("|","|https?://|")()});h.breaks=r({},h.gfm,{br:l(h.br)("{2,}","*")(),text:l(h.gfm.text)("{2,}","*")()});q.rules=h;q.output=function(a,b,e){return(new q(b,e)).output(a)};q.prototype.output=function(a){for(var b=
"",e,d;a;)if(d=this.rules.escape.exec(a))a=a.substring(d[0].length),b+=d[1];else if(d=this.rules.autolink.exec(a))a=a.substring(d[0].length),"@"===d[2]?(e=":"===d[1].charAt(6)?this.mangle(d[1].substring(7)):this.mangle(d[1]),d=this.mangle("mailto:")+e):d=e=n(d[1]),b+='<a href="'+d+'">'+e+"</a>";else if(d=this.rules.url.exec(a))a=a.substring(d[0].length),d=e=n(d[1]),b+='<a href="'+d+'">'+e+"</a>";else if(d=this.rules.tag.exec(a))a=a.substring(d[0].length),b+=this.options.sanitize?n(d[0]):d[0];else if(d=
this.rules.link.exec(a))a=a.substring(d[0].length),b+=this.outputLink(d,{href:d[2],title:d[3]});else if((d=this.rules.reflink.exec(a))||(d=this.rules.nolink.exec(a)))a=a.substring(d[0].length),e=(d[2]||d[1]).replace(/\s+/g," "),(e=this.links[e.toLowerCase()])&&e.href?b+=this.outputLink(d,e):(b+=d[0].charAt(0),a=d[0].substring(1)+a);else if(d=this.rules.strong.exec(a))a=a.substring(d[0].length),b+="<strong>"+this.output(d[2]||d[1])+"</strong>";else if(d=this.rules.em.exec(a))a=a.substring(d[0].length),
b+="<em>"+this.output(d[2]||d[1])+"</em>";else if(d=this.rules.code.exec(a))a=a.substring(d[0].length),b+="<code>"+n(d[2],!0)+"</code>";else if(d=this.rules.br.exec(a))a=a.substring(d[0].length),b+="<br>";else if(d=this.rules.del.exec(a))a=a.substring(d[0].length),b+="<del>"+this.output(d[1])+"</del>";else if(d=this.rules.text.exec(a))a=a.substring(d[0].length),b+=n(this.smartypants(d[0]));else if(a)throw Error("Infinite loop on byte: "+a.charCodeAt(0));return b};q.prototype.outputLink=function(a,
b){return"!"!==a[0].charAt(0)?'<a href="'+n(b.href)+'"'+(b.title?' title="'+n(b.title)+'"':"")+">"+this.output(a[1])+"</a>":'<img src="'+n(b.href)+'" alt="'+n(a[1])+'"'+(b.title?' title="'+n(b.title)+'"':"")+">"};q.prototype.smartypants=function(a){return this.options.smartypants?a.replace(/--/g,"\u2014").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201c").replace(/"/g,"\u201d").replace(/\.{3}/g,"\u2026"):a};q.prototype.mangle=function(a){for(var b=
"",e=a.length,d=0,c;d<e;d++)c=a.charCodeAt(d),0.5<Math.random()&&(c="x"+c.toString(16)),b+="&#"+c+";";return b};p.parse=function(a,b){return(new p(b)).parse(a)};p.prototype.parse=function(a){this.inline=new q(a.links,this.options);this.tokens=a.reverse();for(a="";this.next();)a+=this.tok();return a};p.prototype.next=function(){return this.token=this.tokens.pop()};p.prototype.peek=function(){return this.tokens[this.tokens.length-1]||0};p.prototype.parseText=function(){for(var a=this.token.text;"text"===
this.peek().type;)a+="\n"+this.next().text;return this.inline.output(a)};p.prototype.tok=function(){switch(this.token.type){case "space":return"";case "hr":return"<hr>\n";case "heading":return"<h"+this.token.depth+' id="'+this.options.headerPrefix+this.token.text.toLowerCase().replace(/[^\w]+/g,"-")+'">'+this.inline.output(this.token.text)+"</h"+this.token.depth+">\n";case "code":if(this.options.highlight){var a=this.options.highlight(this.token.text,this.token.lang);null!=a&&a!==this.token.text&&
(this.token.escaped=!0,this.token.text=a)}this.token.escaped||(this.token.text=n(this.token.text,!0));return"<pre><code"+(this.token.lang?' class="'+this.options.langPrefix+this.token.lang+'"':"")+">"+this.token.text+"</code></pre>\n";case "table":var b,e,d,c,a="<thead>\n<tr>\n";for(e=0;e<this.token.header.length;e++)b=this.inline.output(this.token.header[e]),a+="<th",this.token.align[e]&&(a+=' style="text-align:'+this.token.align[e]+'"'),a+=">"+b+"</th>\n";a+="</tr>\n</thead>\n<tbody>\n";for(e=0;e<
this.token.cells.length;e++){b=this.token.cells[e];a+="<tr>\n";for(c=0;c<b.length;c++)d=this.inline.output(b[c]),a+="<td",this.token.align[c]&&(a+=' style="text-align:'+this.token.align[c]+'"'),a+=">"+d+"</td>\n";a+="</tr>\n"}a+="</tbody>\n";return"<table>\n"+a+"</table>\n";case "blockquote_start":for(a="";"blockquote_end"!==this.next().type;)a+=this.tok();return"<blockquote>\n"+a+"</blockquote>\n";case "list_start":e=this.token.ordered?"ol":"ul";for(a="";"list_end"!==this.next().type;)a+=this.tok();
return"<"+e+">\n"+a+"</"+e+">\n";case "list_item_start":for(a="";"list_item_end"!==this.next().type;)a+="text"===this.token.type?this.parseText():this.tok();return"<li>"+a+"</li>\n";case "loose_item_start":for(a="";"list_item_end"!==this.next().type;)a+=this.tok();return"<li>"+a+"</li>\n";case "html":return this.token.pre||this.options.pedantic?this.token.text:this.inline.output(this.token.text);case "paragraph":return"<p>"+this.inline.output(this.token.text)+"</p>\n";case "text":return"<p>"+this.parseText()+
"</p>\n"}};t.exec=t;k.options=k.setOptions=function(a){r(k.defaults,a);return k};k.defaults={gfm:!0,tables:!0,breaks:!1,pedantic:!1,sanitize:!1,smartLists:!1,silent:!1,highlight:null,langPrefix:"lang-",smartypants:!1,headerPrefix:""};k.Parser=p;k.parser=p.parse;k.Lexer=s;k.lexer=s.lex;k.InlineLexer=q;k.inlineLexer=q.output;return k.parse=k})();

// Actual renderer that uses this code
Jsonary.render.register({
	renderHtml: function (data, context) {
		var markdown = data.value();
		// Strip all HTML tags
		markdown = markdown.replace(/<[^<]*>/g, '');
		var html = marked(Jsonary.escapeHtml(markdown));
		if (markdown.indexOf("\n") === -1) {
			html = html.replace("<p>", "").replace("</p>", "");
		}
		html = html.replace(/(["'])javascript/i, function (whole, quoteChar) {
			return quoteChar + "tricksy";
		});
		return '<span class="markdown">' + html + '</span>';
	},
	filter: {
		readOnly: true,
		type: "string",
		filter: function (data, schemas) {
			return schemas.containsFormat('markdown');
		}
	}
});